﻿/*
"DirectX 11을 이용한 3D 게임 프로그래밍 입문"을 참고함
*/
#ifndef MAIN_H
#define MAIN_H

#include <Windows.h>

#include "DX11StaticVariables.h"

#pragma comment (lib, "d3d11.lib")
#pragma comment (lib, "d3dx11.lib")
#pragma comment (lib, "d3dx10.lib")
#pragma warning (disable:4005) 

int WINAPI WinMain(HINSTANCE hInstance,
    HINSTANCE hPrevInstance,
    LPSTR lpCmdLine,
    int nCmdShow);

LRESULT CALLBACK WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

bool InitD3D(HWND hWnd);

bool InitD3DDevice();
bool D3DInitialized(HRESULT hResult);
bool Is4XMSAACompatible();
void InitSwapChainDesc(HWND hWnd);
bool InitSwapChain();
void InitRenderView();
bool InitDepthStencilView();
void BindViewsToOutputMerger();
void InitViewPort();
bool InitPipeline();
void InitInputLayout(ID3DBlob* VS);
void InitConstantBuffer();
void InitResources();

void RenderFrame();
void UpdateEnvironment();

void ClearD3D();

#endif